// pages/me/vip/index.js
import api from '../../../utils/Api.js'
const app = getApp()

Page({
  /**
   * 页面的初始数据
   */
  data: {
    value1: 1,
    value2: 0.1,

    is_vip: 0,
    vip_endtime: null,
    vip_price: 49.9,

    order: {}
  },

  handleChange1({ detail }) {
    this.setData({
      value1: detail.value
    })
  },

  handleChange2({ detail }) {
    this.setData({
      value2: detail.value
    })
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let userInfo = app.globalData.userInfo
    let is_vip = userInfo.is_vip
    let vip_endtime = userInfo.vip_endtime
    this.setData({
      is_vip: is_vip,
      vip_endtime: vip_endtime
    })
  },

  // 获取VIP单价
  getVipPrice: function () {
    api.me.vipPrice().then(res => {
      if (!res.code) {
        this.setData({
          vip_price: res.price
        })
      }else{
        wx.showToast({
          title: res.msg
        })
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  /**
   * 立即购买/续费
   */
  handleClick: function (){
    let that = this
    let year = this.data.value1
    let params = {
      year: year
    }
    // 获取支付参数
    api.me.vipOrder(params).then(res => {
      if (res.code == 0) {
        console.log("获取支付参数", res)
        that.setData({
          order: res.data
        })
        // 发起微信支付
        wx.requestPayment({
          timeStamp: '' + res.result.timeStamp,
          nonceStr: '' + res.result.nonceStr,
          package: '' + res.result.package,
          signType: '' + res.result.signType,
          paySign: '' + res.result.paySign,
          success: function (ret) {
            that.setOrderPaid(that.data.order.order_id, function (res) {
              // 支付同步回调结果
              console.log(res)
            })
          }
        })
      }else{
        wx.showToast({
          title: res.msg,
        })
      }
    })
  },
  /**
   * 同步支付结果回调：重置订单状态
   */
  setOrderPaid(id, callback) {
    let that = this
    let params = {
      order_id: id
    }
    api.me.vipOrderPaied(params).then(res => {
      typeof callback == "function" && callback()
    })
  }
})